% function integrates flow in cartesian coords
% for use with rossdiff.m

function RK4 = integ(y)

n=3;
h=.001; % !!if you change here, MUST change in rossreturnmap.m!!
hh=h/2;
h6=h/6;

dydt=rossdiff(y);

for i=1:n
    ytmp(i)=y(i)+hh*dydt(i);
end

dytmp=rossdiff(ytmp);

for j=1:n
    ytmp(j)=y(j)+hh*dytmp(j);
end

dym=rossdiff(ytmp);

for k=1:n
    ytmp(k)=y(k)+h*dym(k);
    dym(k)=dytmp(k)+dym(k);
end

dytmp=rossdiff(ytmp);

for m=1:n
    RK4(m)=y(m)+h6*(dydt(m)+dytmp(m)+2*dym(m));
end

return