% function calculates derivatives in cylindrical coordinates
% for use with retRK4pol.m

function polretd = derivpol(z,z_r)

a=.2; % !!must change in rossdiff.m as well!!
b=.2;
c=5.7;

% dr/dt = -z*cos(theta)+a*r*(sintheta)^2 == f_1
% dtheta/dt = 1+(z/r)*sin(theta)+a*sin(theta)*cos(theta) == f_2
% dz/dt = b+z*(r*cos(theta)-c) == f_3

% dr/dtheta = f_1/f_2
polretd(1)=(a*z(1)*(sin(z_r))^2-z(3)*cos(z_r))/...
    (1+z(3)*sin(z_r)/z(1)+a*sin(z_r)*cos(z_r));

% dt/dtheta = 1/f_2
polretd(2)=1.0/(1+z(3)*sin(z_r)/z(1)+a*sin(z_r)*cos(z_r));

% dz/dtheta = f_3/f_2
polretd(3)=(b+z(3)*(z(1)*cos(z_r)-c))/...
    (1+z(3)*sin(z_r)/z(1)+a*sin(z_r)*cos(z_r));

return