% function uses fourth order Runge Kutta and
% "Henon's trick" to land on the section
% NOTE: !timestep (h) is now r*dtheta!
% for use with polretd.m

function retRK4pol = rpolinteg(y_p,tpp,ang)

n=3;

% convert to cylindrical coords
pol(1)=sqrt(y_p(1)^2+y_p(2)^2);

if ((y_p(1)>0)&(y_p(2)>0))
    pol(2)=atan(y_p(2)/y_p(1));
elseif (y_p(1)<0)
    pol(2)=pi+atan(y_p(2)/y_p(1));
else
    pol(2)=2*pi+atan(y_p(2)/y_p(1));
end

pol(3)=y_p(3);

% define timesteps
h=ang-pol(2);
hh=h/2;
h6=h/6;

poltmp_r=pol(2);

dpoldt=polretd(pol,poltmp_r);

pol(2)=tpp;

for i=1:n
    poltmp(i)=pol(i)+hh*dpoldt(i);
end

poltmp_r=poltmp_r+hh;
dpoltmp=polretd(poltmp,poltmp_r);

%xtmp_r=h+hh;
for j=1:n
    poltmp(j)=pol(j)+hh*dpoltmp(j);
end

dpolm=polretd(poltmp,poltmp_r);

for k=1:n
    poltmp(k)=pol(k)+h*dpolm(k);
    dpolm(k)=dpoltmp(k)+dpolm(k);
end

poltmp_r=ang;
dpoltmp=polretd(poltmp,poltmp_r);

for m=1:n
    retRK4pol(m)=pol(m)+h6*(dpoldt(m)+...
    dpoltmp(m)+2*dpolm(m));
end

return